VST 3 SDK VST 3.7 SDK for developing VST plug-in

Classes | Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
Module Class Referenceabstract

`#include <module.h>`

## Classes
struct | Snapshot

## Public Types
using | Ptr = std::shared_ptr< Module >
using | PathList = std::vector< std::string >
using | SnapshotList = std::vector< Snapshot >

## Public Member Functions
const std::string & | getName () const noexcept
const std::string & | getPath () const noexcept
const PluginFactory & | getFactory () const noexcept
bool | isBundle () const noexcept

## Static Public Member Functions
static Ptr | create (const std::string &path, std::string &errorDescription)
static PathList | getModulePaths ()
static SnapshotList | getSnapshots (const std::string &modulePath)
static Optional< std::string > | getModuleInfoPath (const std::string &modulePath)
| get the path to the module info json file if it exists More...

## Protected Member Functions
virtual | ~Module () noexcept=default
virtual bool | load (const std::string &path, std::string &errorDescription)=0

## Protected Attributes
PluginFactory | factory {nullptr}
std::string | name
std::string | path
bool | hasBundleStructure {true}

## Member Typedef Documentation

## ◆ Ptr

using Ptr = std::shared_ptr<Module>

## ◆ PathList

using PathList = std::vector<std::string>

## ◆ SnapshotList

using SnapshotList = std::vector<Snapshot>

## Constructor & Destructor Documentation

## ◆ ~Module()

virtual ~Module | ( |  | ) |
| protected virtual default noexcept

## Member Function Documentation

## ◆ create()

Module::Ptr create | ( | const std::string & | path,
|  | std::string & | errorDescription
| ) |  |
| static

## ◆ getModulePaths()

Module::PathList getModulePaths | ( |  | ) |
| static

## ◆ getSnapshots()

Module::SnapshotList getSnapshots | ( | const std::string & | modulePath | ) |
| static

## ◆ getModuleInfoPath()

Optional< std::string > getModuleInfoPath | ( | const std::string & | modulePath | ) |
| static

get the path to the module info json file if it exists

## ◆ getName()

const std::string & getName | ( |  | ) | const
| inline noexcept

## ◆ getPath()

const std::string & getPath | ( |  | ) | const
| inline noexcept

## ◆ getFactory()

const PluginFactory & getFactory | ( |  | ) | const
| inline noexcept

## ◆ isBundle()

bool isBundle | ( |  | ) | const
| inline noexcept

## ◆ load()

virtual bool load | ( | const std::string & | path,
|  | std::string & | errorDescription
| ) |  |
| protected pure virtual

## Member Data Documentation

## ◆ factory

PluginFactory factory {nullptr}
| protected

## ◆ name

std::string name
| protected

## ◆ path

std::string path
| protected

## ◆ hasBundleStructure

bool hasBundleStructure {true}
| protected

Empty

Copyright © Steinberg Media Technologies GmbH. All Rights Reserved. This documentation is under this license.